; arrg! GNU checks not for undefined labels!!!

	GLOBAL FFPMultiply

.code

FFPMultiply:
	movem.l d3-d5,-(a7)
	move.l  16(a7),d2	; D2 wert1
	moveq   #0,d0	; wert2H
	move.l  20(a7),d1	; D1 wert2L
	move.l  24(a7),a0
	moveq   #0,d3	; resultH
	moveq   #0,d4 ; resultL

	moveq   #0,d5	; D5 negative flag
	tst.l   d2
	bgt    wert1neg
	beq    ResultNoOverflow
	neg.l   d2
	moveq   #-1,d5	; is negative
wert1neg:
	tst.l   d1	; D1 wert2L
	bge     wert2Lneg
	neg.l   d1
	not.w	d5 ; invert negative flag
wert2Lneg:
	cmp.l   d1,d2	; wert2L<wert1
	ble     CalcLoop
	exg    d1,d2	; D0 wert1L
CalcLoop:
	lsr.l   #1,d2
;	btst   #0,d2
;	beq     LowBitZero
	bcc     LowBitZero
	add.l   d1,d4		; resultL += wert2L
	addx.l   d0,d3	; resultH += wert2H + overflow
LowBitZero:
	add.l   d1,d1	; wert2L <<= 1;
	addx.l  d0,d0	; wert2H <<=1 + overflow
NoSwapWert:
;	lsr.l   #1,d2
	tst.l   d2
	bne     CalcLoop

; here we finished calculation
	clr.b   d4
	rol.l   #6,d4	; resultL >>= 26
	move.l  d3,d2
	lsl.l   #6,d2	; resultH <<= 6
	or.b    d4,d2
	tst.w   d5	; test negative flag
	beq     ResultOk
	neg.l   d2
ResultOk:
	moveq   #0,d0	; return false (no overflow)
	andi.l  #$FC000000,d3
	beq     ResultNoOverflow
	moveq   #1,d0
ResultNoOverflow:
	move.l  d2,(a0)	; write value back
	movem.l (a7)+,d3-d5
	rts
